--- old/usr/src/cmd/sgs/dump/common/dump.c	Tue Feb 27 22:54:10 2018
+++ new/usr/src/cmd/sgs/dump/common/dump.c	Tue Feb 27 22:54:10 2018
@@ -477,6 +477,7 @@
 demangled_name(char *s)
 {
 	static char	*buf = NULL;
+	size_t		buflen = 0;
 	const char	*dn;
 	size_t		len;
 
@@ -485,20 +486,23 @@
 	/*
 	 * If not demangled, just return the symbol name
 	 */
-	if (strcmp(s, dn) == 0)
+	if (dn == s)
 		return (s);
 
+	len = strlen(dn) + strlen(s) + 4;
+
+	if (buflen < len) {
+		free(buf);
+		if ((buf = malloc(len)) == NULL)
+			return (s);
+		buflen = len;
+	}
+
 	/*
 	 * Demangled. Format it
 	 */
-	if (buf != NULL)
-		free(buf);
-
-	len = strlen(dn) + strlen(s) + 4;
-	if ((buf = malloc(len)) == NULL)
-		return (s);
-
-	(void) snprintf(buf, len, "%s\t[%s]", dn, s);
+	(void) snprintf(buf, buflen, "%s\t[%s]", dn, s);
+	free(dn);
 	return (buf);
 }
 
@@ -526,7 +530,7 @@
 		adj = 8;
 
 	while (range > 0) {
-		char		*sym_name = (char *)0;
+		char		*sym_name = NULL;
 		int		type, bind;
 		int		specsec;
 		unsigned int	shndx;
